/*  Ims-control.c - Small control tool for ImSafe

    ImSafe - Host Based Intrusion Detection
    Version 0.2.2 - Alpha

    Copyright (C) 2001  Laurent Eschenauer 
    <laurent_e@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



 Supported orders to the driver:
 
  IMM_SAY_HELLO 1
  IMM_SAY_HI    2 + argument
  IMM_BUFFER_RESET 3
  IMM_START 4 
  IMM_STOP 5
  IMM_SET_NAME 6 + argument
  IMM_EXECVE_TRACE_ON 7
  IMM_EXECVE_TRACE_OFF 8
*/
  
#define DEBUG 1
#define SCREENOUTPUT 1
#define DEVICE "/dev/imsensor"

#include <stdio.h>                 /*Pour les entrees et sorties  */
#include <sys/types.h>             /*Types systemes:pid,..        */

#include <time.h>
#include <string.h>

#include <fcntl.h>


/********************************************************************/
/* int main(int argc,char * argv[]                                  */
/*                                                                  */
/********************************************************************/

int main(int argc, char *argv[])
{
  /* ============= variables locales  ====================*/ 
 
  int imm_device;
  char *device;

  int cmd,i,result;
  unsigned int order;
  char *arg=NULL;
 
  /* ============= gestion des arguments  ====================*/ 


  device=strdup(DEVICE);

  if (argc <  2)
    exit(errorHandler(1,0,argv[0]));
   
  for (i=1;i<argc;i+=2)
    {
      switch (*(argv[i]+1))
	{
	case 'o': 
	  order=atoi(argv[i+1]);
	  break;
	case 'a':
	  arg=argv[i+1];
	  break;
	case 'd':
	  device=strdup(argv[i+1]);
	  break;
	default: 
	  exit(errorHandler(1,0,argv[0]));
	};
    };

  fprintf(stdout,"Ims-control\nSending order to device %s \n",device);
  fprintf(stdout,"!!! Warning !!!\n If you do any mistakes you may crash the kernel !!\n");
  
  
  if ((imm_device = open(device,O_RDONLY,0)) <0)
    exit(errorHandler(2,0,DEVICE));
 
  result=ioctl(imm_device,order,arg);

  printf("Result was : %d\n",result);
  close(imm_device);


}

int errorHandler(int type, long arg, char * argString)
{
  switch (type)
    {
    case 1:
      fprintf(stderr,"usage %s -o <order> -a <arg> -d <device>\n",argString);
      fprintf(stderr,"-o 1 : ask driver to say Hello through Syslogd\n");
      fprintf(stderr,"-o 2 -a name : ask driver to say Hello <name> via Syslogd\n");
      fprintf(stderr,"-o 3 : reset of the buffer\n");
      fprintf(stderr,"-o 4 : start tracing\n");
      fprintf(stderr,"-o 5 : end tracing\n");
      fprintf(stderr,"-o 6 -a name : Set name of application to monitor\n");
      fprintf(stderr,"-o 7 : trace execve on\n");
      fprintf(stderr,"-o 8 : trace execve off\n");
      return(1);
    case 2:
      fprintf(stderr,"error opening file %s\n",argString);
      return(2);
    case 3:
      fprintf(stderr,"error closing %s.\n",argString);
      return(3);
    default:
      fprintf(stderr,"Unknown error\n");
      return(-1);    
   };
}





