/*  Ims-learn.c - Command line tool to learn profile

    ImSafe - Host Based Intrusion Detection
    Version 0.2.2 - Alpha

    Copyright (C) 2001  Laurent Eschenauer 
    <laurent_e@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/



#include <stdio.h>                 /*Pour les entrees et sorties*/
#include <sys/types.h>             /*Types systemes:pid,..      */
#include <math.h>
#include <time.h>
#include <string.h>
#include "learning.h"

#define SEQ_LEN 6;

/********************************************************************/
/* int main(int argc,char * argv[]                                  */
/*                                                                  */
/********************************************************************/

int main(int argc, char *argv[])
{
  struct Learn_config *config;
  int i;

  config=(struct Learn_config *) malloc(sizeof(struct Learn_config));
  config->seq_len=SEQ_LEN;


  if (argc<2)
    exit(errorHandler(1,0,argv[0]));

  i=1;
  while (i<argc)
    {
      switch (*(argv[i]+1))
	{
	case 't':
	  config->trace_path=argv[i+1];
	  i+=2;
	  break;
	case 'l': 
	  config->seq_len=atoi(argv[i+1]);
	  i+=2;
	  break;
	case 'v':
	  config->verbose=1;
	  i++;
	  break;
	case 'o':
	  config->output_path=argv[i+1];
	  config->output_db=1;
	  i+=2;
	  break;
	case 'i':
	  config->input_path=argv[i+1];
	  config->load_db=1;
	  i+=2;
	  break;
	default: 
	  exit(errorHandler(1,0,argv[0]));
	};
    };

  do_learn(config);

}
 

